int[][] squares;
int squareSize = 100;
int rows = 4;
int cols = 8;

int redFactor = 255;
int greenFactor = 255;
int blueFactor = 255;
int alphaFactor= 255;
Boolean auto = false;

void setup() {
  size(800, 400);
  squares = new int[rows][cols];
  generateRandomSquares();
  frameRate(2);
}

void draw() {
  background(255);
  if (auto) {
    frameRate(1);
    generateRandomSquares();
    setColorFactors();
  }
    else {
    frameRate(30);
  }
  drawSquares();
}

void generateRandomSquares() {
  for (int i = 0; i < rows; i++) {
    for (int j = 0; j < cols; j++) {
      squares[i][j] = (int) random(2);
    }
  }
}

void drawSquares() {
  int x = 0;
  int y = 0;

  for (int i = 0; i < rows; i++) {
    for (int j = 0; j < cols; j++) {
      int squareColor = squares[i][j];
      color newColor = color(squareColor * redFactor, squareColor * greenFactor, squareColor * blueFactor, squareColor*alphaFactor);
      fill(newColor);
      noStroke();
      rect(x, y, squareSize, squareSize);

      x += squareSize;
    }

    x = 0;
    y += squareSize;
  }
}

void mousePressed() {
  int colIndex = mouseX / squareSize;
  int rowIndex = mouseY / squareSize;

  if (colIndex >= 0 && colIndex < cols && rowIndex >= 0 && rowIndex < rows) {
    flipSquareColor(rowIndex, colIndex);
    setColorFactors();
  }
}

void flipSquareColor(int row, int col) {
  squares[row][col] = 1 - squares[row][col];
}

void keyPressed() {
  if (key == 'n' || key == 'N') {
    generateRandomSquares();
    setColorFactors();
  }
  if (key == 'a' || key == 'A') {
    auto =! auto;
  }
  if (key == 's' || key == 'S') {
    saveFrame("colors-####.png"); 
  }
}

void setColorFactors() {
  String redString = "";
  String greenString = "";
  String blueString = "";
  String alphaString = "";
  for (int i = 0; i < rows; i++) {
    for (int j = 0; j < cols; j++) {
      if (i == 0) {
        redString = redString+(str(squares[i][j]));
      }
      if (i == 1) {
        greenString = greenString+(str(squares[i][j]));
      }
      if (i == 2) {
        blueString = blueString+(str(squares[i][j]));
      }
      if (i == 3) {
        alphaString = alphaString+(str(squares[i][j]));
      }
    }
  }

  redFactor = Integer.parseInt(redString, 2);
  greenFactor = Integer.parseInt(greenString, 2);
  blueFactor = Integer.parseInt(blueString, 2);
  alphaFactor = Integer.parseInt(alphaString, 2);
  println(redString);
  println("redFactor = "+redFactor);
}
